       IDENTIFICATION DIVISION.
       PROGRAM-ID.              IAPMDI28
      *  Statement:  Licensed Materials - Property of IBM
      *
      *              MA1C SupportPac
      *              (c) Copyright IBM Corp. 1995, 1996.
      *
      *              All rights reserved.
      *
      *              U.S. Government Users Restricted Rights - use,
      *              duplication or disclosure restricted by GSA
      *              ADP Schedule Contract with IBM Corp.
      *
      *
      *           COBOL370
      *AUTHOR.                  PETER EDWARDS
      *WRITTEN.                 OCTOBER   1995
      *REMARKS.
      *           COBOL MPP TO RECEIVE AND INSERT SINGLE SEGMENT
      *           MESSAGES
      *
       ENVIRONMENT DIVISION.
       DATA DIVISION.

       WORKING-STORAGE SECTION.
       77  FILLER               PIC X(16) VALUE '*** BEGIN WS ***'.

      ******************************************************************
      *            IMS DECLARATIONS
      ******************************************************************
       77  DEF-MOD              PIC X(8) VALUE 'DFSMO1  '.
       77  GU-FUNC              PIC X(4) VALUE 'GU  '.
       77  GN-FUNC              PIC X(4) VALUE 'GN  '.
       77  ISRT-FUNC            PIC X(4) VALUE 'ISRT'.
       77  ROLL-FUNC            PIC X(4) VALUE 'ROLL'.
       77  DISPLAY-LL           PIC 9(5).
       77  DISPLAY-ZZ           PIC 9(5).

       01  INPUT-MESSAGE.
           02  IN-LL            PIC  S9(4) COMP.
           02  IN-ZZ            PIC  S9(4) COMP.
           02  IN-TRANCODE      PIC  X(8).
           02  IN-DATA.
               03  IN-LINE1     PIC  X(80).
               03  FILLER       PIC  X(32687).

       01  OUTPUT-MESSAGE.
           02  OUT-LL           PIC S9(4) COMP VALUE +164.
           02  OUT-ZZ           PIC S9(4) COMP VALUE +0.
           02  OUT-TRAN-TEXT    PIC X(6) VALUE ' TRAN:'.
           02  OUT-TRANCODE     PIC X(8).
           02  OUT-LTRM-TEXT    PIC X(6) VALUE ' LTRM:'.
           02  OUT-LTERM        PIC X(8).
           02  OUT-USER-TEXT    PIC X(6) VALUE ' USER:'.
           02  OUT-USERID       PIC X(8).
           02  OUT-DATE-TEXT    PIC X(6) VALUE ' DATE:'.
           02  OUT-DATE         PIC X(8).
           02  OUT-TIME-TEXT    PIC X(6) VALUE ' TIME:'.
           02  OUT-TIME         PIC X(8).
           02  OUT-DATA-TEXT    PIC X(10) VALUE ' MSG DATA:'.
           02  OUT-DATA         PIC X(80).

       01  DLI-MSG.
           02  DLIMSG-1         PIC X(18) VALUE 'ERROR ON DLI CALL '.
           02  DLIMSG-CALL      PIC X(10).
           02  DLIMSG-2         PIC X(18) VALUE '. STATUS CODE WAS '.
           02  DLIMSG-STAT      PIC X(2).
           02  DLIMSG-3         PIC X(22) VALUE ' '.

       LINKAGE SECTION.
       01  IOPCB.
           02  IO-LTERM         PIC X(8).
           02  IO-RESV          PIC X(2).
           02  IO-STATUS        PIC X(2).
           02  IO-DATE          PIC XXXX.
           02  IO-TIME          PIC XXXX.
           02  IO-SEQNO         PIC XXXX.
           02  IO-MODN          PIC X(8).
           02  IO-USERID        PIC X(8).
           02  IO-GROUPID       PIC X(8).

       PROCEDURE DIVISION.
           ENTRY 'DLITCBL' USING IOPCB.
           PERFORM GET-IMS-MSG UNTIL (IO-STATUS = 'QC').
           GOBACK.

      ****************************************************************
      * GET IMS MESSAGES FROM INPUT QUEUE AND PROCESS
      ****************************************************************
       GET-IMS-MSG.
           MOVE SPACES                   TO OUT-DATA.
           MOVE SPACES                   TO IN-DATA.
           MOVE SPACES                   TO INPUT-MESSAGE.
           CALL 'CBLTDLI' USING GU-FUNC, IOPCB,
                                INPUT-MESSAGE.
           EVALUATE IO-STATUS
                WHEN '  '
                  ACCEPT OUT-DATE        FROM DAY
                  ACCEPT OUT-TIME        FROM TIME
                  DISPLAY 'PROGRAM IAPMDI28'
                  DISPLAY 'GU MESSAGE: '
                  DISPLAY 'DATE:==>'     OUT-DATE
                  DISPLAY 'TIME:==>'     OUT-TIME
                  MOVE  IN-LL            TO DISPLAY-LL
                  DISPLAY 'LL BYTES:==>' DISPLAY-LL
                  MOVE  IN-ZZ            TO DISPLAY-ZZ
                  DISPLAY 'ZZ BYTES:==>' DISPLAY-ZZ
                  DISPLAY 'LTERM/TPIPE   :==>' IO-LTERM
                  DISPLAY 'MODNAME :==>' IO-MODN
                  DISPLAY 'USERID  :==>' IO-USERID
                  DISPLAY 'GROUP   :==>' IO-GROUPID
                  DISPLAY 'TRANCODE:==>' IN-TRANCODE
                  DISPLAY 'DATA:==>'     IN-LINE1
                  MOVE IN-LINE1          TO OUT-DATA
                  MOVE IN-TRANCODE       TO OUT-TRANCODE
                  MOVE IO-LTERM          TO OUT-LTERM
                  MOVE IO-USERID         TO OUT-USERID
                  PERFORM ISRT-MESSAGE
                WHEN 'QC'
                  DISPLAY 'QC STATUS CODE RETURNED'
                WHEN NOT 'QC'
                  MOVE 'GU#MSGQ'  TO DLIMSG-CALL
                  MOVE IO-STATUS  TO DLIMSG-STAT
                  PERFORM D-RETURN-CODE
           END-EVALUATE.

      ****************************************************************
      * ERROR ROUTINE TO CATER FOR UNEXPECTED DL1 STATUS CODES
      ****************************************************************
       D-RETURN-CODE.
            DISPLAY DLI-MSG.
            MOVE DLI-MSG TO OUT-DATA.
            PERFORM ISRT-MESSAGE.
            GOBACK.

      ****************************************************************
      * ROUTINE TO INSERT A MESSAGE TO THE TERMINAL
      ****************************************************************
       ISRT-MESSAGE.
            IF IO-MODN = 'MQIMSVS'
               MOVE 'MQIMSVS'         TO DEF-MOD
            ELSE
               MOVE 'DFSMO1'          TO DEF-MOD.
            CALL 'CBLTDLI' USING  ISRT-FUNC, IOPCB,
                OUTPUT-MESSAGE, DEF-MOD.
            IF IO-STATUS NOT = SPACES
                 MOVE 'ISRT#M'   TO DLIMSG-CALL
                 MOVE IO-STATUS  TO DLIMSG-STAT
                 DISPLAY DLI-MSG
                 CALL 'CBLTDLI' USING ROLL-FUNC, IOPCB.
